Index: i386/i386/critical.c
===========================================================================
--- sys/i386/i386/critical.c	2003/10/30 14:48:07	#11
+++ i386/i386/critical.c	2003/10/30 14:48:07
@@ -30,144 +30,17 @@
 
 #include <sys/param.h>
 #include <sys/systm.h>
-#include <sys/signalvar.h>
-#include <sys/kernel.h>
-#include <sys/lock.h>
-#include <sys/mutex.h>
-#include <sys/pcpu.h>
 #include <sys/proc.h>
-#include <sys/sysctl.h>
-#include <sys/ucontext.h>
-#include <machine/clock.h>
 #include <machine/critical.h>
 
-#ifdef SMP
-#include <machine/privatespace.h>
-#include <machine/smp.h>
-#else
-/*
- * XXX this mess to get sched_ithd() and call_fast_unpend()
- */
-#include <sys/bus.h>
-#include <machine/apic.h>
-#include <machine/frame.h>
-#include <i386/isa/icu.h>
-#include <i386/isa/intr_machdep.h>
-#endif
-
-void i386_unpend(void);		/* NOTE: not static, called from assembly */
-
 /*
- * cpu_unpend() -	called from critical_exit() inline after quick
- *			interrupt-pending check.
- */
-void
-cpu_unpend(void)
-{
-	register_t eflags;
-	struct thread *td;
-
-	td = curthread;
-	eflags = intr_disable();
-	if (PCPU_GET(int_pending)) {
-		++td->td_intr_nesting_level;
-		i386_unpend();
-		--td->td_intr_nesting_level;
-	}
-	intr_restore(eflags);
-}
-
-/*
  * cpu_critical_fork_exit() - cleanup after fork
+ *
+ *	Enable interrupts in the saved copy of eflags.
  */
 void
 cpu_critical_fork_exit(void)
 {
 
-	enable_intr();
-}
-
-/*
- * Called from cpu_unpend or called from the assembly vector code
- * to process any interrupts which may have occured while we were in
- * a critical section.
- *
- * 	- interrupts must be disabled
- *	- td_critnest must be 0
- *	- td_intr_nesting_level must be incremented by the caller
- *
- * NOT STATIC (called from assembly)
- */
-void
-i386_unpend(void)
-{
-	struct clockframe frame;
-
-	frame.cf_cs = SEL_KPL;
-	frame.cf_eip = (register_t)i386_unpend;
-	frame.cf_eflags = PSL_KERNEL;
-	KASSERT(curthread->td_critnest == 0, ("unpend critnest != 0"));
-	KASSERT((read_eflags() & PSL_I) == 0, ("unpend interrupts enabled1"));
-	curthread->td_critnest = 1;
-	for (;;) {
-		u_int32_t mask;
-		int irq;
-
-		/*
-		 * Fast interrupts have priority
-		 */
-		if ((mask = PCPU_GET(fpending)) != 0) {
-			irq = bsfl(mask);
-			PCPU_SET(fpending, mask & ~(1 << irq));
-			call_fast_unpend(irq);
-			KASSERT((read_eflags() & PSL_I) == 0,
-			    ("unpend interrupts enabled2 %d", irq));
-			continue;
-		}
-
-		/*
-		 * Threaded interrupts come next
-		 */
-		if ((mask = PCPU_GET(ipending)) != 0) {
-			irq = bsfl(mask);
-			PCPU_SET(ipending, mask & ~(1 << irq));
-			sched_ithd((void *)irq);
-			KASSERT((read_eflags() & PSL_I) == 0,
-			    ("unpend interrupts enabled3 %d", irq));
-			continue;
-		}
-
-		/*
-		 * Software interrupts and delayed IPIs are last
-		 *
-		 * XXX give the bits #defined names.  see also
-		 * isa/xxx_vector.s
-		 */
-		if ((mask = PCPU_GET(spending)) != 0) {
-			irq = bsfl(mask);
-			PCPU_SET(spending, mask & ~(1 << irq));
-			switch(irq) {
-			case 0:		/* bit 0 - hardclock */
-				hardclock_process(&frame);
-				break;
-			case 1:		/* bit 1 - statclock */
-				if (profprocs != 0)
-					profclock(&frame);
-				if (pscnt == psdiv)
-					statclock(&frame);
-				break;
-			}
-			KASSERT((read_eflags() & PSL_I) == 0,
-			    ("unpend interrupts enabled4 %d", irq));
-			continue;
-		}
-		break;
-	}
-	/*
-	 * Interrupts are still disabled, we can safely clear int_pending 
-	 * and td_critnest.
-	 */
-	KASSERT((read_eflags() & PSL_I) == 0, ("unpend interrupts enabled5"));
-	PCPU_SET(int_pending, 0);
-	curthread->td_critnest = 0;
+	curthread->td_md.md_savecrit = read_eflags() | PSL_I;
 }
Index: i386/i386/db_interface.c
===========================================================================
--- sys/i386/i386/db_interface.c	2003/10/30 14:48:07	#16
+++ i386/i386/db_interface.c	2003/10/30 14:48:07
@@ -334,5 +334,6 @@
 db_show_mdpcpu(struct pcpu *pc)
 {
 
+	db_printf("APIC ID      = %d\n", pc->pc_apic_id);
 	db_printf("currentldt   = 0x%x\n", pc->pc_currentldt);
 }
Index: i386/i386/db_trace.c
===========================================================================
--- sys/i386/i386/db_trace.c	2003/10/30 14:48:07	#15
+++ i386/i386/db_trace.c	2003/10/30 14:48:07
@@ -225,8 +225,8 @@
 		if (strcmp(name, "calltrap") == 0 ||
 		    strcmp(name, "fork_trampoline") == 0)
 			frame_type = TRAP;
-		else if (strncmp(name, "Xintr", 5) == 0 ||
-		    strncmp(name, "Xfastintr", 9) == 0)
+		else if (strncmp(name, "Xatpic_intr", 11) == 0 ||
+		    strncmp(name, "Xapic_isr", 9) == 0)
 			frame_type = INTERRUPT;
 		else if (strcmp(name, "Xlcall_syscall") == 0 ||
 		    strcmp(name, "Xint0x80_syscall") == 0)
Index: i386/i386/exception.s
===========================================================================
--- sys/i386/i386/exception.s	2003/10/30 14:48:07	#18
+++ i386/i386/exception.s	2003/10/30 14:48:07
@@ -37,12 +37,8 @@
 #include "opt_npx.h"
 
 #include <machine/asmacros.h>
-#include <sys/mutex.h>
 #include <machine/psl.h>
 #include <machine/trap.h>
-#ifdef SMP
-#include <machine/smptests.h>		/** various SMP options */
-#endif
 
 #include "assym.s"
 
@@ -77,9 +73,6 @@
  * %ss segment registers, but does not mess with %ds, %es, or %fs.  Thus we
  * must load them with appropriate values for supervisor mode operation.
  */
-#define	IDTVEC(name)	ALIGN_TEXT; .globl __CONCAT(X,name); \
-			.type __CONCAT(X,name),@function; __CONCAT(X,name):
-#define	TRAP(a)		pushl $(a) ; jmp alltraps
 
 MCOUNT_LABEL(user)
 MCOUNT_LABEL(btrap)
@@ -233,13 +226,6 @@
  */
 #include "i386/i386/vm86bios.s"
 
-/*
- * Include what was once config+isa-dependent code.
- * XXX it should be in a stand-alone file.  It's still icu-dependent and
- * belongs in i386/isa.
- */
-#include "i386/isa/vector.s"
-
 	.data
 	ALIGN_DATA
 
@@ -250,6 +236,7 @@
  */
 	.text
 	SUPERALIGN_TEXT
+	.globl	doreti
 	.type	doreti,@function
 doreti:
 	FAKE_MCOUNT(bintr)		/* init "from" bintr -> doreti */
@@ -334,9 +321,3 @@
 	movl	$0,TF_ERR(%esp)	/* XXX should be the error code */
 	movl	$T_PROTFLT,TF_TRAPNO(%esp)
 	jmp	alltraps_with_regs_pushed
-
-#ifdef APIC_IO
-#include "i386/isa/apic_ipl.s"
-#else
-#include "i386/isa/icu_ipl.s"
-#endif /* APIC_IO */
Index: i386/i386/genassym.c
===========================================================================
--- sys/i386/i386/genassym.c	2003/10/30 14:48:07	#33
+++ i386/i386/genassym.c	2003/10/30 14:48:07
@@ -39,6 +39,7 @@
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD: src/sys/i386/i386/genassym.c,v 1.144 2003/10/01 23:46:07 peter Exp $");
 
+#include "opt_apic.h"
 #include "opt_compat.h"
 #include "opt_kstack_pages.h"
 
@@ -70,8 +71,8 @@
 #include <nfs/rpcv2.h>
 #include <nfsclient/nfs.h>
 #include <nfsclient/nfsdiskless.h>
-#ifdef SMP
-#include <machine/apic.h>
+#ifdef DEV_APIC
+#include <machine/apicreg.h>
 #endif
 #include <machine/cpu.h>
 #include <machine/sigframe.h>
@@ -178,6 +179,7 @@
 ASSYM(ENOENT, ENOENT);
 ASSYM(EFAULT, EFAULT);
 ASSYM(ENAMETOOLONG, ENAMETOOLONG);
+ASSYM(MAXCOMLEN, MAXCOMLEN);
 ASSYM(MAXPATHLEN, MAXPATHLEN);
 ASSYM(BOOTINFO_SIZE, sizeof(struct bootinfo));
 ASSYM(BI_VERSION, offsetof(struct bootinfo, bi_version));
@@ -192,10 +194,6 @@
 ASSYM(PC_SIZEOF, sizeof(struct pcpu));
 ASSYM(PC_PRVSPACE, offsetof(struct pcpu, pc_prvspace));
 ASSYM(PC_CURTHREAD, offsetof(struct pcpu, pc_curthread));
-ASSYM(PC_INT_PENDING, offsetof(struct pcpu, pc_int_pending));
-ASSYM(PC_IPENDING, offsetof(struct pcpu, pc_ipending));
-ASSYM(PC_FPENDING, offsetof(struct pcpu, pc_fpending));
-ASSYM(PC_SPENDING, offsetof(struct pcpu, pc_spending));
 ASSYM(PC_FPCURTHREAD, offsetof(struct pcpu, pc_fpcurthread));
 ASSYM(PC_IDLETHREAD, offsetof(struct pcpu, pc_idlethread));
 ASSYM(PC_CURPCB, offsetof(struct pcpu, pc_curpcb));
@@ -206,13 +204,14 @@
 ASSYM(PC_CPUID, offsetof(struct pcpu, pc_cpuid));
 ASSYM(PC_CURPMAP, offsetof(struct pcpu, pc_curpmap));
 
-#ifdef SMP
+#ifdef DEV_APIC
 ASSYM(LA_VER, offsetof(struct LAPIC, version));
 ASSYM(LA_TPR, offsetof(struct LAPIC, tpr));
 ASSYM(LA_EOI, offsetof(struct LAPIC, eoi));
 ASSYM(LA_SVR, offsetof(struct LAPIC, svr));
 ASSYM(LA_ICR_LO, offsetof(struct LAPIC, icr_lo));
 ASSYM(LA_ICR_HI, offsetof(struct LAPIC, icr_hi));
+ASSYM(LA_ISR, offsetof(struct LAPIC, isr0));
 #endif
 
 ASSYM(KCSEL, GSEL(GCODE_SEL, SEL_KPL));
Index: i386/i386/identcpu.c
===========================================================================
--- sys/i386/i386/identcpu.c	2003/10/30 14:48:07	#38
+++ i386/i386/identcpu.c	2003/10/30 14:48:07
@@ -55,12 +55,10 @@
 #include <machine/asmacros.h>
 #include <machine/clock.h>
 #include <machine/cputypes.h>
+#include <machine/intr_machdep.h>
+#include <machine/md_var.h>
 #include <machine/segments.h>
 #include <machine/specialreg.h>
-#include <machine/md_var.h>
-
-#include <i386/isa/icu.h>
-#include <i386/isa/intr_machdep.h>
 
 #define	IDENTBLUE_CYRIX486	0
 #define	IDENTBLUE_IBMCPU	1
Index: i386/i386/initcpu.c
===========================================================================
--- sys/i386/i386/initcpu.c	2003/10/30 14:48:07	#19
+++ i386/i386/initcpu.c	2003/10/30 14:48:07
@@ -474,7 +474,6 @@
 static void
 init_ppro(void)
 {
-#ifndef SMP
 	u_int64_t	apicbase;
 
 	/*
@@ -483,7 +482,6 @@
 	apicbase = rdmsr(MSR_APICBASE);
 	apicbase &= ~APICBASE_ENABLED;
 	wrmsr(MSR_APICBASE, apicbase);
-#endif
 }
 
 /*
Index: i386/i386/intr_machdep.c
===========================================================================
*** /dev/null	Thu Oct 30 14:47:44 2003
--- i386/i386/intr_machdep.c	Thu Oct 30 14:48:09 2003
***************
*** 0 ****
--- 1,296 ----
+ /*-
+  * Copyright (c) 2003 John Baldwin <jhb@FreeBSD.org>
+  * All rights reserved.
+  *
+  * Redistribution and use in source and binary forms, with or without
+  * modification, are permitted provided that the following conditions
+  * are met:
+  * 1. Redistributions of source code must retain the above copyright
+  *    notice, this list of conditions and the following disclaimer.
+  * 2. Redistributions in binary form must reproduce the above copyright
+  *    notice, this list of conditions and the following disclaimer in the
+  *    documentation and/or other materials provided with the distribution.
+  * 3. Neither the name of the author nor the names of any co-contributors
+  *    may be used to endorse or promote products derived from this software
+  *    without specific prior written permission.
+  *
+  * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+  * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+  * SUCH DAMAGE.
+  *
+  * $FreeBSD$
+  */
+ 
+ /*
+  * Machine dependent interrupt code for i386.  For the i386, we have to
+  * deal with different PICs.  Thus, we use the passed in vector to lookup
+  * an interrupt source associated with that vector.  The interrupt source
+  * describes which PIC the source belongs to and includes methods to handle
+  * that source.
+  */
+ 
+ #include "opt_ddb.h"
+ 
+ #include <sys/param.h>
+ #include <sys/bus.h>
+ #include <sys/interrupt.h>
+ #include <sys/lock.h>
+ #include <sys/ktr.h>
+ #include <sys/kernel.h>
+ #include <sys/mutex.h>
+ #include <sys/proc.h>
+ #include <sys/syslog.h>
+ #include <sys/systm.h>
+ #include <machine/intr_machdep.h>
+ #ifdef DDB
+ #include <ddb/ddb.h>
+ #endif
+ 
+ #define	MAX_STRAY_LOG	5
+ 
+ typedef void (*mask_fn)(int vector);
+ 
+ static int intrcnt_index;
+ static struct intsrc *interrupt_sources[NUM_IO_INTS];
+ static struct mtx intr_table_lock;
+ 
+ static void	intr_init(void *__dummy);
+ static void	intrcnt_setname(const char *name, int index);
+ static void	intrcnt_updatename(struct intsrc *is);
+ static void	intrcnt_register(struct intsrc *is);
+ 
+ /*
+  * Register a new interrupt source with the global interrupt system.
+  * The global interrupts need to be disabled when this function is
+  * called.
+  */
+ int
+ intr_register_source(struct intsrc *isrc)
+ {
+ 	int error, vector;
+ 
+ 	vector = isrc->is_pic->pic_vector(isrc);
+ 	if (interrupt_sources[vector] != NULL)
+ 		return (EEXIST);
+ 	/*
+ 	 * Ok, so this is kind of a nasty optimization that only works
+ 	 * because sizeof(int) == sizeof(void *) on i386.  If we passed
+ 	 * in the actual vector to ithread_create and then used wrapper
+ 	 * functions for disable_intsrc and enable_intsrc, then we'd
+ 	 * have to go lookup in the table everytime we enabled/disabled
+ 	 * the interrupt source.  That involves looking at a lock, etc.
+ 	 * and is just ugly.  Instead, we cast the pointer to the intsrc
+ 	 * to an int (yuck) and pass in the actual PIC methods meaning
+ 	 * that when we enable/disable an interrupt we call the PIC
+ 	 * methods directly.
+ 	 */
+ 	error = ithread_create(&isrc->is_ithread, (intptr_t)isrc, 0,
+ 	    (mask_fn)isrc->is_pic->pic_disable_source,
+ 	    (mask_fn)isrc->is_pic->pic_enable_source, "irq%d:", vector);
+ 	if (error)
+ 		return (error);
+ 	mtx_lock_spin(&intr_table_lock);
+ 	if (interrupt_sources[vector] != NULL) {
+ 		mtx_unlock_spin(&intr_table_lock);
+ 		ithread_destroy(isrc->is_ithread);
+ 		return (EEXIST);
+ 	}
+ 	intrcnt_register(isrc);
+ 	interrupt_sources[vector] = isrc;
+ 	mtx_unlock_spin(&intr_table_lock);
+ 	return (0);
+ }
+ 
+ struct intsrc *
+ intr_lookup_source(int vector)
+ {
+ 
+ 	return (interrupt_sources[vector]);
+ }
+ 
+ int
+ intr_add_handler(const char *name, int vector, driver_intr_t handler,
+     void *arg, enum intr_type flags, void **cookiep)
+ {
+ 	struct intsrc *isrc;
+ 	int error;
+ 
+ 	isrc = intr_lookup_source(vector);
+ 	if (isrc == NULL)
+ 		return (EINVAL);
+ 	error = ithread_add_handler(isrc->is_ithread, name, handler, arg,
+ 	    ithread_priority(flags), flags, cookiep);
+ 	if (error == 0) {
+ 		intrcnt_updatename(isrc);
+ 		isrc->is_pic->pic_enable_intr(isrc);
+ 		isrc->is_pic->pic_enable_source(isrc);
+ 	}
+ 	return (error);
+ }
+ 
+ int
+ intr_remove_handler(void *cookie)
+ {
+ 	int error;
+ 
+ 	error = ithread_remove_handler(cookie);
+ #ifdef XXX
+ 	if (error == 0)
+ 		intrcnt_updatename(/* XXX */);
+ #endif
+ 	return (error);
+ }
+ 
+ void
+ intr_execute_handlers(struct intsrc *isrc, struct intrframe *iframe)
+ {
+ 	struct ithd *it;
+ 	struct intrhand *ih;
+ 	int error, vector;
+ 
+ 	/*
+ 	 * We count software interrupts when we process them.  The
+ 	 * code here follows previous practice, but there's an
+ 	 * argument for counting hardware interrupts when they're
+ 	 * processed too.
+ 	 */
+ 	atomic_add_long(isrc->is_count, 1);
+ 	atomic_add_int(&cnt.v_intr, 1);
+ 
+ 	/*
+ 	 * Execute fast interrupt handlers directly.
+ 	 * To support clock handlers, if a handler registers
+ 	 * with a NULL argument, then we pass it a pointer to
+ 	 * a trapframe as its argument.
+ 	 */
+ 	it = isrc->is_ithread;
+ 	ih = TAILQ_FIRST(&it->it_handlers);
+ 	critical_enter();
+ 	if (ih == NULL)
+ 		error = EINVAL;
+ 	else if (ih->ih_flags & IH_FAST) {
+ 		TAILQ_FOREACH(ih, &it->it_handlers, ih_next) {
+ 			MPASS(ih->ih_flags & IH_FAST);
+ 			CTR3(KTR_INTR, "%s: executing handler %p(%p)",
+ 			    __func__, ih->ih_handler,
+ 			    ih->ih_argument == NULL ? iframe :
+ 			    ih->ih_argument);
+ 			if (ih->ih_argument == NULL)
+ 				ih->ih_handler(iframe);
+ 			else
+ 				ih->ih_handler(ih->ih_argument);
+ 		}
+ 		isrc->is_pic->pic_enable_source(isrc);
+ 		error = 0;
+ 	} else
+ 		error = ithread_schedule(it, !cold);
+ 	critical_exit();
+ 	if (error == EINVAL) {
+ 		vector = isrc->is_pic->pic_vector(isrc);
+ 		atomic_add_long(isrc->is_straycount, 1);
+ 		if (*isrc->is_straycount < MAX_STRAY_LOG)
+ 			log(LOG_ERR, "stray irq%d\n", vector);
+ 		else if (*isrc->is_straycount == MAX_STRAY_LOG)
+ 			log(LOG_CRIT,
+ 			    "too many stray irq %d's: not logging anymore\n",
+ 			    vector);
+ 	}
+ }
+ 
+ void
+ intr_resume(void)
+ {
+ 	struct intsrc **isrc;
+ 	int i;
+ 
+ 	mtx_lock_spin(&intr_table_lock);
+ 	for (i = 0, isrc = interrupt_sources; i < NUM_IO_INTS; i++, isrc++)
+ 		if (*isrc != NULL && (*isrc)->is_pic->pic_resume != NULL)
+ 			(*isrc)->is_pic->pic_resume(*isrc);
+ 	mtx_unlock_spin(&intr_table_lock);
+ }
+ 
+ void
+ intr_suspend(void)
+ {
+ 	struct intsrc **isrc;
+ 	int i;
+ 
+ 	mtx_lock_spin(&intr_table_lock);
+ 	for (i = 0, isrc = interrupt_sources; i < NUM_IO_INTS; i++, isrc++)
+ 		if (*isrc != NULL && (*isrc)->is_pic->pic_suspend != NULL)
+ 			(*isrc)->is_pic->pic_suspend(*isrc);
+ 	mtx_unlock_spin(&intr_table_lock);
+ }
+ 
+ static void
+ intrcnt_setname(const char *name, int index)
+ {
+ 
+ 	snprintf(intrnames + (MAXCOMLEN + 1) * index, MAXCOMLEN + 1, "%-*s",
+ 	    MAXCOMLEN, name);
+ }
+ 
+ static void
+ intrcnt_updatename(struct intsrc *is)
+ {
+ 
+ 	intrcnt_setname(is->is_ithread->it_td->td_proc->p_comm, is->is_index);
+ }
+ 
+ static void
+ intrcnt_register(struct intsrc *is)
+ {
+ 	char straystr[MAXCOMLEN + 1];
+ 
+ 	/* mtx_assert(&intr_table_lock, MA_OWNED); */
+ 	KASSERT(is->is_ithread != NULL, ("%s: isrc with no ithread", __func__));
+ 	is->is_index = intrcnt_index;
+ 	intrcnt_index += 2;
+ 	snprintf(straystr, MAXCOMLEN + 1, "stray irq%d",
+ 	    is->is_pic->pic_vector(is));
+ 	intrcnt_updatename(is);
+ 	is->is_count = &intrcnt[is->is_index];
+ 	intrcnt_setname(straystr, is->is_index + 1);
+ 	is->is_straycount = &intrcnt[is->is_index + 1];
+ }
+ 
+ static void
+ intr_init(void *dummy __unused)
+ {
+ 
+ 	intrcnt_setname("???", 0);
+ 	intrcnt_index = 1;
+ 	mtx_init(&intr_table_lock, "intr table", NULL, MTX_SPIN);
+ }
+ SYSINIT(intr_init, SI_SUB_INTR, SI_ORDER_FIRST, intr_init, NULL)
+ 
+ #ifdef DDB
+ /*
+  * Dump data about interrupt handlers
+  */
+ DB_SHOW_COMMAND(irqs, db_show_irqs)
+ {
+ 	struct intsrc **isrc;
+ 	int i, quit, verbose;
+ 
+ 	quit = 0;
+ 	if (strcmp(modif, "v") == 0)
+ 		verbose = 1;
+ 	else
+ 		verbose = 0;
+ 	isrc = interrupt_sources;
+ 	db_setup_paging(db_simple_pager, &quit, DB_LINES_PER_PAGE);
+ 	for (i = 0; i < NUM_IO_INTS && !quit; i++, isrc++)
+ 		if (*isrc != NULL)
+ 			db_dump_ithread((*isrc)->is_ithread, verbose);
+ }
+ #endif
